<?php
//A simple function to get data stored in a custom field
if(!function_exists('get_custom_field')) {
function get_custom_field($field) {
	global $post;
	$custom_field = get_post_meta($post->ID, $field, true);
	echo $custom_field;
}
}

// Adds a custom section to the "advanced" Post and Page edit screens
function vsp_add_custom_box() {
	if( function_exists( 'add_meta_box' )) {
		add_meta_box( 'vsp_custom_box_1', __( 'Vibe SEO Pack Panel' ), 'vsp_inner_custom_box_1', 'post', 'normal', 'high' );
		add_meta_box( 'vsp_custom_box_1', __( 'Vibe SEO Pack Panel' ), 'vsp_inner_custom_box_1', 'page', 'normal', 'high' );
	}
}

/* Prints the inner fields for the custom post/page section */
function vsp_inner_custom_box_1() {
	global $post;

	// Use nonce for verification ... ONLY USE ONCE!
	echo '<input type="hidden" name="vsp_noncename" id="vsp_noncename" value="' . wp_create_nonce( plugin_basename(__FILE__) ) . '" />';

	echo '<div id="seo-box-right">';

    if ( get_post_meta($post->ID, 'vsp_keyword', true) ) {
      $url            = get_bloginfo('wpurl');
      $strfilter      = apply_filters('the_content', $post->post_content);
      $strfilter      = strtolower($strfilter);
      $titlefilter    = apply_filters('the_title', $post->post_title);
      $titlefilter    = strtolower($titlefilter);

      $vsp_content    = strip_tags($post->post_content);
      $vsp_content    = strtolower($vsp_content);
      $vsp_words      = str_word_count(strtolower($vsp_content),1);
      $vsp_word_count = count($vsp_words);

      $res            = array();
      $kwd            = strtolower(get_post_meta($post->ID, 'vsp_keyword', true));
      $kwd_count      = preg_match_all("/\b$kwd\b/msiU", $vsp_content, $res);

      $kwd_density    = ($kwd_count / $vsp_word_count) * 100;
      $kwdper         = number_format($kwd_density,2);

      // Check keyword density
      if ( $kwdper < 1 ) {
        echo '<p class="vsp-bad">'.__("Keyword Density" ).': '.$kwdper.'% - <strong>'.__("is too low!" ).'</strong></p>';
      } elseif ( $kwdper > 5.5 ) {
        echo '<p class="vsp-bad">'.__("Keyword Density" ).': '.$kwdper.'% - <strong>'.__("is too high!" ).'</strong></p>';
      } else {
        echo '<p class="vsp-ok">'.__("Keyword Density" ).': '.$kwdper.'%</p>';
      }
      // SEO score based on the keyword density
      if ($kwdper>=1 && $kwdper<=1.5) { $densityscore = 0.25; }
      if ($kwdper>1.5 && $kwdper<=2) { $densityscore = 0.27; }
      if ($kwdper>2 && $kwdper<=2.5) { $densityscore = 0.29; }
      if ($kwdper>2.5 && $kwdper<=3) { $densityscore = 0.31; }
      if ($kwdper>3 && $kwdper<=3.5) { $densityscore = 0.33; }
      if ($kwdper>3.5 && $kwdper<=4) { $densityscore = 0.35; }
      if ($kwdper>4 && $kwdper<=4.5) { $densityscore = 0.37; }
      if ($kwdper>4.5 && $kwdper<=5) { $densityscore = 0.39; }
      if ($kwdper>5 && $kwdper<=5.5) { $densityscore = 0.4; }
      if ($kwdper>5.5 && $kwdper<=6) { $densityscore = 0.1; }

      // Check if keyword exist in the URL
      $urlkwd = preg_match_all("/.*$kwd.*/i",$url,$res);
      if ( $urlkwd > 0 ) {
        $urlscore = 0.03;
      }

      // Check if keyword exist in the title
      $customtitle = get_post_meta($post->ID, 'vsp_title', true);
      if ($customtitle) {
        $titlekwd = preg_match_all("/.*$kwd.*/i",$customtitle,$res);
      } else {
        $titlekwd = preg_match_all("/.*$kwd.*/i",$titlefilter,$res);
      }
      if ( $titlekwd > 0 ) {
        echo '<p class="vsp-ok">'.__("Found title containing main keyword" ).'</p>'; $titlescore = 0.12;
      } else {
        echo '<p class="vsp-bad">'.__("Title not containing main keyword" ).'</p>';
      }

      // Check if keyword exist in the custom description
      $customdesc = strtolower(get_post_meta($post->ID, 'vsp_description', true));
      if ($customdesc) {
        $customdesckwd = preg_match_all("/.*$kwd.*/i",$customdesc,$res);
        if ( $customdesckwd > 0 ) {} else {
          echo '<p class="vsp-bad">'.__("Description not containing main keyword" ).'</p>'; $descscore = -0.1;
        }
      }

      // Check if keyword exist in H1 tag
      $h1tags = preg_match_all("/(<h1.*>)(.*$kwd.*)(<\/h1>)/i",$strfilter,$res);
      if ( $h1tags > 0 ) {
        echo '<p class="vsp-ok">'.__("Found H1 tag containing main keyword" ).'</p>'; $h1score = 0.1;
      } else {
        echo '<p class="vsp-bad">'.__("No \"H1\" tag containing main keyword" ).'</p>';
      }

      // Check if keyword exist in H2 tag
      $h2tags = preg_match_all("/(<h2.*>)(.*$kwd.*)(<\/h2>)/i",$strfilter,$res);
      if ( $h2tags > 0 ) {
        echo '<p class="vsp-ok">'.__("Found H2 tag containing main keyword" ).'</p>'; $h2score = 0.08;
      } else {
        echo '<p class="vsp-bad">'.__("No \"H2\" tag containing main keyword" ).'</p>';
      }

      // Check if keyword exist in H3 tag
      $h3tags = preg_match_all("/(<h3.*>)(.*$kwd.*)(<\/h3>)/i",$strfilter,$res);
      if ( $h3tags > 0 ) {
        echo '<p class="vsp-ok">'.__("Found H3 tag containing main keyword" ).'</p>'; $h3score = 0.04;
      } else {
        echo '<p class="vsp-bad">'.__("No \"H3\" tag containing main keyword" ).'</p>';
      }

      // Check if keyword exist in strong tag
      $bolddtags = preg_match_all("/(<strong.*>)(.*$kwd.*)(<\/strong>)/i",$strfilter,$res);
      if ( $bolddtags > 0 ) {
        echo '<p class="vsp-ok">'.__("Found \"strong\" <b>(b)</b> tag containing main keyword" ).'</p>'; $boldscore = 0.03;
      } else {
        echo '<p class="vsp-bad">'.__("No \"strong\" <b>(b)</b> tag containing main keyword" ).'</p>';
      }

      // Check if keyword exist in italic tag
      $emdtags = preg_match_all("/(<em.*>)(.*$kwd.*)(<\/em>)/i",$strfilter,$res);
      if ( $emdtags > 0 ) {
        echo '<p class="vsp-ok">'.__("Found \"em\" <i>(i)</i> tag containing main keyword" ).'</p>'; $emscore = 0.03;
      } else {
        echo '<p class="vsp-bad">'.__("No \"em\" <i>(i)</i> tag containing main keyword" ).'</p>';
      }

      // Check if keyword exist in alt image tag
      $imgtags = preg_match_all("/<img\s[^>]*alt=\".*$kwd.*\"[^>]*>/i",$strfilter,$res);
      if ( $imgtags > 0 ) {
        echo '<p class="vsp-ok">'.__("Found \"alt\" image tag containing main keyword" ).'</p>'; $imgscore = 0.05;
      } else {
        echo '<p class="vsp-bad">'.__("No \"alt\" image tag containing main keyword" ).'</p>';
      }

      // Check if internal link exist
      $int_url = str_replace('http://www.', '', $url);
      $int_url = str_replace('http://', '', $url);
      $int_url = str_replace('/', '\/', $url);
      $intlink = preg_match_all("/<.*href=\".*$int_url.*\"[^>]*>(.*)<\/a>/isxmU",$strfilter,$res);
      if ( $intlink > 0 ) {
        echo '<p class="vsp-ok">'.__("Found internal link" ).'</p>'; $linkscore = 0.02;
      } else {
        echo '<p class="vsp-bad">'.__("No internal link can be found" ).'</p>';
      }

      // count words
      if ( $vsp_word_count > 199 ) {
        $wcountscore = 0.1;
      } else {
        echo '<p class="vsp-bad">'.__("You should add more words to your content" ).'</p>';
      }


    } else {
      // If keyword is not set
      echo '<p>'.__("Set your post main keyword and hit the <b>save draft</b> button if you are creating a new post, or the <b>update</b> button if you are editing a published post.  I will analyze your post content and title and will give you hints for what should be done for better search engine optimization. After optimizing your post you might want to use the search helpers on the left to get in touch with others interested by the same topic as you." ).'</p>';
    }
	echo '</div>';

    // Calculate the SEO rating score
    $score = ( $densityscore + $urlscore + $titlescore + $h1score + $h2score + $h3score + $boldscore + $emscore + $imgscore + $linkscore + $wcountscore + $descscore ) * 100;

    if ((isset($_GET['action'])) && ($_GET['action']='edit')) { $updatebut = '<input name="save" type="submit" class="button" id="publish" accesskey="p" value="Update" />'; }
	echo '<div id="seo-box-left">';
	echo '<p><label for="vsp_keyword"><b>'. __("Main Keyword") .'</b>:</label> ';
	echo '<input type="text" name="vsp_keyword" value="'. get_post_meta($post->ID, 'vsp_keyword', true) .'" /> '.$updatebut.'</p>';
    if ( $score < 60 ) {
        echo '<p><span style="color:red;font-size:14px;font-weight:bold;">'.__("Overall Post SEO score" ).': '.$score.'%</span></p>';
    } else {
        echo '<p><span style="color:green;font-size:14px;font-weight:bold;">'.__("Overall Post SEO score" ).': '.$score.'%</span></p>';
    }
	echo '<p><label for="vsp_description">' . __("Enter custom <b>title</b>" ) . ': </label>';
	echo '<textarea name="vsp_title" maxlength="70" style="width:100%;height:26px;" >'.get_post_meta($post->ID, 'vsp_title', true).'</textarea></p>';
	echo '<p><label for="vsp_description">' . __("Enter custom <b>description</b>" ) . ': </label>';
	echo '<textarea name="vsp_description" maxlength="160" lengthcut="true" style="width:100%;" >'.get_post_meta($post->ID, 'vsp_description', true).'</textarea></p>';
	echo '<p><b>Search</b>: <a href="http://search.twitter.com/search?q='.$kwd.'" target="_blank">Twitter</a> | <a href="http://www.google.com/search?hl=en&q='.$kwd.'" target="_blank">Google</a> | <a href="http://www.google.com/search?hl=en&q=[%22'.$kwd.'%22+%22powered+by+wordpress%22]" target="_blank">WP blogs</a> | <a href="http://en.wikipedia.org/w/index.php?title=Special%3ASearch&redirs=1&search='.$kwd.'&fulltext=Search&ns0=1" target="_blank">Wiki</a> | <a style="color:black;" href="http://www.vibethemes.com/wordppress-seo-get-in-touch-with-people/" target="_blank">what\'s this?</a></p>';
	echo '<script type="text/javascript" src="'.WP_CONTENT_URL.'/plugins/vibe-seo-pack/lib/js/charcount.js"></script></div>';

	echo '<div style="clear:both;"></div>';

}

/* When the post is saved, saves our custom data */
function vsp_save_postdata($post_id, $post) {

	// verify this came from the our screen and with proper authorization,
	// because save_post can be triggered at other times
	if ( !wp_verify_nonce( $_POST['vsp_noncename'], plugin_basename(__FILE__) )) {
	return $post->ID;
	}

	// Is the user allowed to edit the post or page?
	if ( 'page' == $_POST['post_type'] ) {
		if ( !current_user_can( 'edit_page', $post->ID ))
		return $post->ID;
	} else {
		if ( !current_user_can( 'edit_post', $post->ID ))
		return $post->ID;
	}

	// OK, we're authenticated: we need to find and save the data
	// We'll put it into an array to make it easier to loop though.

	$mydata['vsp_keyword'] = $_POST['vsp_keyword'];
	$mydata['vsp_title'] = $_POST['vsp_title'];
	$mydata['vsp_description'] = $_POST['vsp_description'];

	// Add values of $mydata as custom fields

	foreach ($mydata as $key => $value) { //Let's cycle through the $mydata array!
		if( $post->post_type == 'revision' ) return; //don't store custom data twice
		$value = implode(',', (array)$value); //if $value is an array, make it a CSV (unlikely)
		if(get_post_meta($post->ID, $key, FALSE)) { //if the custom field already has a value
			update_post_meta($post->ID, $key, $value);
		} else { //if the custom field doesn't have a value
			add_post_meta($post->ID, $key, $value);
		}
		if(!$value) delete_post_meta($post->ID, $key); //delete if blank
	}

}

/* Use the admin_menu action to define the custom boxes */
add_action('admin_menu', 'vsp_add_custom_box');

/* Use the save_post action to do something with the data entered */
add_action('save_post', 'vsp_save_postdata', 1, 2); // save the custom field