<?php
/*
Plugin Name: Vibe SEO Pack
Plugin URI: http://www.vibethemes.com/wordpress-plugins/vibe-seo-pack-wordpress-plugin/
Description: Vibe SEO Pack is a simple powerful and easy to use SEO tool to optimize your website for search engines without having to edit a single line of code. WordPress plugin by  <a href="http://www.vibethemes.com/" title="premium wordpress themes">VibeThemes</a>.
Author: VibeThemes.com
Version: 1.1.1
Author URI: http://www.vibethemes.com
*/

// Set roles for access levels
$role_admin     = 'administrator';
$opt = get_option('vsp_options');

if (!defined('WP_CONTENT_URL')) {
	define('WP_CONTENT_URL', get_option('siteurl').'/wp-content');
}

// Set the default values
function vsp_defaults() {
    $default = array(
        'footer_link'       => 'link',
        'category_index'    => 'noindex',
        'archive_index'     => 'noindex',
        'search_index'      => 'noindex',
        'tag_index'         => 'index',
        'author_index'      => 'noindex',
        'login_index'       => 'noindex',
        'admin_index'       => 'noindex',
        'category_nofollow' => 'follow',
        'page_nofollow'     => 'follow',
        'archive_nofollow'  => 'follow',
        'register_nofollow' => 'nofollow',
        'login_nofollow'    => 'nofollow'
    );
return $default;
}

// Reset to default function
if (isset($_POST['reset-vm'])) {
    update_option('vsp_options', vsp_defaults());
    $msg = '<div class="updated fade" id="message"><p><strong>Settings Reset to Default</strong></p></div>';
}
// Updated message
if ( ($_GET['page']=='vsp-dashboard') && ($_GET['settings-updated']=='true') ) {
    $msg = '<div class="updated fade" id="message"><p><strong>Settings Updated</strong></p></div>';
}

// Install SQL database
function vsp_db_install() {
  add_option('vsp_options', vsp_defaults());
}
// Add DB tables and set default values on plugin install
register_activation_hook(__FILE__,'vsp_db_install');

// Create menu page(s)
function page_vsp_admin_options(){ global $role_admin;

    add_menu_page('Vibe SEO Pack', 'Vibe SEO Pack', $role_admin,  'vsp-dashboard' , 'vsp_dashboard', 'div');
	add_submenu_page('vsp-dashboard', 'Dashboard', 'Dashboard', $role_admin, 'vsp-dashboard', 'vsp_dashboard');
}
// Include admin pages
function vsp_dashboard()      {include_once('admin/vsp-dashboard.php');}

// Register the plugin menu into WP
add_action('admin_menu', 'page_vsp_admin_options');

// Load plugin CSS
wp_enqueue_style( 'vsp_style', plugins_url( $path = '/vibe-seo-pack/lib/style.css'), array() );

// Include plugin specific functions
include_once('lib/functions.php');

// Include meta box
include_once('lib/meta-box.php');

// Admin head scripts
function vsp_admin_head() { ?>
<script type="text/javascript">
    var $jq = jQuery.noConflict();
    $jq(document).ready(function() { $jq(".fade").fadeIn(1000).fadeTo(1000, 1).fadeOut(1000); });
</script>
<script type="text/javascript">
function showDonate(vspdonate) {
    if ( vspdonate.options[vspdonate.selectedIndex].value == "donate" ) {
        document.getElementById("vspdonatebox").style.display = "block";
        document.getElementById("nohelpbox").style.display = "none";
    } else if ( vspdonate.options[vspdonate.selectedIndex].value == "nohelp" ) {
        document.getElementById("vspdonatebox").style.display = "none";
        document.getElementById("nohelpbox").style.display = "block";
    } else {
        document.getElementById("nohelpbox").style.display = "none";
        document.getElementById("vspdonatebox").style.display = "none";
    }
}
</script>
<?php }
add_action('admin_head', 'vsp_admin_head'); ?>